﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Reflection;
using System.IO;
using System.Text.RegularExpressions;

using System.Windows.Forms;

using aSourceRewriter;
using aMultipleInheritance;
using aExtractInterface;

namespace MultipleInheritanceTest
{
	class Check2
	{
		public static void Do()
		{
			var sr = new zSourceRewriter("MultipleInheritance", "MultipleInheritanceTest\\GeneratedCode.cs");

			//具体的な型を入れたらバグッたことがある
			var memMapSource = zMultipleInheritance.GetSourceCode(new zClassData
			{
				ClassName = "Test",
				NameSpace = "aMultipleInheritance",
				Usings = new[] { "using System;", "using System.Collections.Generic;", "using System.Runtime.Serialization;" }
			}, new[]{ new zInheriData{
				Type = typeof(Dictionary<string, int>),
				Name = "dic"
			}});
			
			sr.Write("Check2_1.cs", memMapSource);

			//匿名変数名でバグッたことがある
			var annoySource = zMultipleInheritance.GetSourceCode(new zClassData
			{
				ClassName = "Annoy",
				NameSpace = "MultipleInheritanceTest",
				Access = eAccess.Internal,
				Usings = new[]{ "using System;", "using System.Collections.Generic;"}
			}, new[]{
				new zInheriData{
					UseSetter = true,
					UseField = true,
					Type = typeof(Check2_Annoy),
					Name = "annoy"
				}
			});

			sr.Write("Check2_2.cs", annoySource);

			var data1 = new zCommentData
			{
				Summary = new[]{"さまりーだよ",
				"いい加減にしてよね"},
			};

			var check23 = new zClassData
			{
				ClassName = "Check2_3",
				NameSpace = "MultipleInheritanceTest",
				CommentData = data1
			};

			var i1 = new zInheriData
			{
				Type = typeof(Check2_3_Class),
				Name = "c23",
				UseField = true
			};

			var x = new zCommentData
				{
					Summary = new[] { "X", "に違いない" },
				};

			i1.MemberMap.Add("X", m =>{ m.CommentData = x; });

			var y = new zCommentData
				{
					Summary = new[] { "Y" },
				};
			i1.MemberMap.Add("Y", m => m.CommentData = y);

			var z = new zCommentData
				{
					Summary = new[] { "Z" },
				};

			i1.MemberMap.Add("Z", m => m.CommentData = z);

			var m0 =new zCommentData{
					Summary = new[]{ "Teki", "Tou", "Da" },
					Params = new string[0],
					Returns = null,
				};
			
			i1.MemberMap.Add("M0", m => m.CommentData = m0);

			var m01 = new zCommentData
				{
					Params = new[] { "bagu", "rase", "ruyo" },
					Returns = @"なんかないんか
あん
ぽん
たんや労が"
				};
			i1.MemberMap.Add("M01", m => m.CommentData = m01);


			var m1 = new zCommentData
				{
					Params = new[] { "ひとつだけ" }
				};

			i1.MemberMap.Add("M1", m => m.CommentData = m1);

			var m11 = new zCommentData
				{
					Summary = new[]{ "paramは消える筈" },
					Params = new[] { "ひとつのところに", "ふたつ" }
				};

			i1.MemberMap.Add("M11", m => m.CommentData = m11);

			var m2 = new zCommentData
				{
					Summary = new[]{ @"M2
desu
ne",
   "それはそれで邪だ" },
					Params = new[]{ @"ふたつ
ふたつ"},
					Returns = "リターンだよ"
				};

			i1.MemberMap.Add("M2",  m => m.CommentData = m2);

			var m21 =  new zCommentData
				{
					Summary = new string[0],
					Params = new[]{ @"ふたつ
ふたつ", "みっつ"}};

			i1.MemberMap.Add("M21", m => m.CommentData = m21);
			
			sr.Write("Check2_3.cs", zMultipleInheritance.GetSourceCode(check23, new[]{i1}));

			var exs = new zExArg
			{
				InterfaceName = "IEx",
				Type = typeof(Check2_3_Class),
				NameSpace = "MultipleInheritanceTest",
			};

			exs.MemberMap.Add("X", new zExMemberArg { CommentData = x });
			exs.MemberMap.Add("Y", new zExMemberArg { CommentData = y });
			exs.MemberMap.Add("Z", new zExMemberArg { CommentData = z });
			exs.MemberMap.Add("M0", new zExMemberArg { CommentData = m0 });
			exs.MemberMap.Add("M01", new zExMemberArg { CommentData = m01 });
			exs.MemberMap.Add("M1", new zExMemberArg { CommentData = m1 });
			exs.MemberMap.Add("M11", new zExMemberArg { CommentData = m11 });
			exs.MemberMap.Add("M2", new zExMemberArg { CommentData = m2 });
			exs.MemberMap.Add("M21", new zExMemberArg { CommentData = m21 });

			sr.Write("Check2_4.cs", zExtractInterface.GetSourceCode(exs));

		}


		
	}

	public class Check2_3_Class
	{
		public int X;
		public int Y { get; set; }
		public event EventHandler Z;
		public void M0() { }
		public void M01() { }
		public void M1(string s) { }
		public void M11(int x) { }
		public int M2(int x, int y)
		{
			Z(null, null); //警告避け
			return 0;
		}
		public int M21(int x, int z) { return 0; }
	}

	public class Check2_Annoy
	{
		public int Huga { get; set; }

		public Func<int> Hego = () => 0;

		public IEnumerable<int> Yield()
		{
			for (int i = 0; i < 10; ++i)
				yield return i;
		}
	}


}
