using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Sample1
{
	public interface IListInterface<T>
	{
		int Capacity { get; set; }
		int Count { get; }
		T this[int index]{ get; set; }
		
		
		void AddRange(IEnumerable<T> collection);
		ReadOnlyCollection<T> AsReadOnly();
		int BinarySearch(int index, int count, T item, IComparer<T> comparer);
		int BinarySearch(T item);
		int BinarySearch(T item, IComparer<T> comparer);
		void Clear();
		bool Contains(T item);
		void CopyTo(T[] array);
		void CopyTo(int index, T[] array, int arrayIndex, int count);
		void CopyTo(T[] array, int arrayIndex);
		bool Exists(Predicate<T> match);
		T Find(Predicate<T> match);
		List<T> FindAll(Predicate<T> match);
		int FindIndex(Predicate<T> match);
		int FindIndex(int startIndex, Predicate<T> match);
		int FindIndex(int startIndex, int count, Predicate<T> match);
		T FindLast(Predicate<T> match);
		int FindLastIndex(Predicate<T> match);
		int FindLastIndex(int startIndex, Predicate<T> match);
		int FindLastIndex(int startIndex, int count, Predicate<T> match);
		void ForEach(Action<T> action);
		List<T>.Enumerator GetEnumerator();
		List<T> GetRange(int index, int count);
		int IndexOf(T item);
		int IndexOf(T item, int index);
		int IndexOf(T item, int index, int count);
		void Insert(int index, T item);
		void InsertRange(int index, IEnumerable<T> collection);
		int LastIndexOf(T item);
		int LastIndexOf(T item, int index);
		int LastIndexOf(T item, int index, int count);
		bool Remove(T item);
		int RemoveAll(Predicate<T> match);
		void RemoveAt(int index);
		void RemoveRange(int index, int count);
		void Reverse();
		void Reverse(int index, int count);
		void Sort();
		void Sort(IComparer<T> comparer);
		void Sort(int index, int count, IComparer<T> comparer);
		void Sort(Comparison<T> comparison);
		T[] ToArray();
		void TrimExcess();
		bool TrueForAll(Predicate<T> match);
		void Add(T item);
		List<TOutput> ConvertAll<TOutput>(Converter<T, TOutput> converter);
	}
}