using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections;

namespace Sample1
{
	public class ListImpl<T>
		: IEnumerable, IEnumerable<T>, ICollection<T>, IList<T>
		, IListInterface<T>
	{
		private List<T> list;
		
		public ListImpl(List<T> list)
		{
			this.list = list;
		}
		
		
		public int Capacity
		{
			get{ return list.Capacity; }
			set{ list.Capacity = value; }
		}
		
		public int Count
		{
			get{ return list.Count; }
		}
		
		public T this[int index]
		{
			get{ return list[index]; }
			set{ list[index] = value; }
		}
		
		public void AddRange(IEnumerable<T> collection)
		{
			list.AddRange(collection);
		}
		
		public ReadOnlyCollection<T> AsReadOnly()
		{
			return list.AsReadOnly();
		}
		
		public int BinarySearch(int index, int count, T item, IComparer<T> comparer)
		{
			return list.BinarySearch(index, count, item, comparer);
		}
		
		public int BinarySearch(T item)
		{
			return list.BinarySearch(item);
		}
		
		public int BinarySearch(T item, IComparer<T> comparer)
		{
			return list.BinarySearch(item, comparer);
		}
		
		public void Clear()
		{
			list.Clear();
		}
		
		public bool Contains(T item)
		{
			return list.Contains(item);
		}
		
		public void CopyTo(T[] array)
		{
			list.CopyTo(array);
		}
		
		public void CopyTo(int index, T[] array, int arrayIndex, int count)
		{
			list.CopyTo(index, array, arrayIndex, count);
		}
		
		public void CopyTo(T[] array, int arrayIndex)
		{
			list.CopyTo(array, arrayIndex);
		}
		
		public bool Exists(Predicate<T> match)
		{
			return list.Exists(match);
		}
		
		public T Find(Predicate<T> match)
		{
			return list.Find(match);
		}
		
		public List<T> FindAll(Predicate<T> match)
		{
			return list.FindAll(match);
		}
		
		public int FindIndex(Predicate<T> match)
		{
			return list.FindIndex(match);
		}
		
		public int FindIndex(int startIndex, Predicate<T> match)
		{
			return list.FindIndex(startIndex, match);
		}
		
		public int FindIndex(int startIndex, int count, Predicate<T> match)
		{
			return list.FindIndex(startIndex, count, match);
		}
		
		public T FindLast(Predicate<T> match)
		{
			return list.FindLast(match);
		}
		
		public int FindLastIndex(Predicate<T> match)
		{
			return list.FindLastIndex(match);
		}
		
		public int FindLastIndex(int startIndex, Predicate<T> match)
		{
			return list.FindLastIndex(startIndex, match);
		}
		
		public int FindLastIndex(int startIndex, int count, Predicate<T> match)
		{
			return list.FindLastIndex(startIndex, count, match);
		}
		
		public void ForEach(Action<T> action)
		{
			list.ForEach(action);
		}
		
		public List<T>.Enumerator GetEnumerator()
		{
			return list.GetEnumerator();
		}
		
		public List<T> GetRange(int index, int count)
		{
			return list.GetRange(index, count);
		}
		
		public int IndexOf(T item)
		{
			return list.IndexOf(item);
		}
		
		public int IndexOf(T item, int index)
		{
			return list.IndexOf(item, index);
		}
		
		public int IndexOf(T item, int index, int count)
		{
			return list.IndexOf(item, index, count);
		}
		
		public void Insert(int index, T item)
		{
			list.Insert(index, item);
		}
		
		public void InsertRange(int index, IEnumerable<T> collection)
		{
			list.InsertRange(index, collection);
		}
		
		public int LastIndexOf(T item)
		{
			return list.LastIndexOf(item);
		}
		
		public int LastIndexOf(T item, int index)
		{
			return list.LastIndexOf(item, index);
		}
		
		public int LastIndexOf(T item, int index, int count)
		{
			return list.LastIndexOf(item, index, count);
		}
		
		public bool Remove(T item)
		{
			return list.Remove(item);
		}
		
		public int RemoveAll(Predicate<T> match)
		{
			return list.RemoveAll(match);
		}
		
		public void RemoveAt(int index)
		{
			list.RemoveAt(index);
		}
		
		public void RemoveRange(int index, int count)
		{
			list.RemoveRange(index, count);
		}
		
		public void Reverse()
		{
			list.Reverse();
		}
		
		public void Reverse(int index, int count)
		{
			list.Reverse(index, count);
		}
		
		public void Sort()
		{
			list.Sort();
		}
		
		public void Sort(IComparer<T> comparer)
		{
			list.Sort(comparer);
		}
		
		public void Sort(int index, int count, IComparer<T> comparer)
		{
			list.Sort(index, count, comparer);
		}
		
		public void Sort(Comparison<T> comparison)
		{
			list.Sort(comparison);
		}
		
		public T[] ToArray()
		{
			return list.ToArray();
		}
		
		public void TrimExcess()
		{
			list.TrimExcess();
		}
		
		public bool TrueForAll(Predicate<T> match)
		{
			return list.TrueForAll(match);
		}
		
		public void Add(T item)
		{
			list.Add(item);
		}
		
		public List<TOutput> ConvertAll<TOutput>(Converter<T, TOutput> converter)
		{
			return list.ConvertAll<TOutput>(converter);
		}
		
		
		IEnumerator IEnumerable.GetEnumerator()
		{
			return (list as IEnumerable).GetEnumerator();
		}
		
		
		IEnumerator<T> IEnumerable<T>.GetEnumerator()
		{
			return (list as IEnumerable<T>).GetEnumerator();
		}
		
		
		int ICollection<T>.Count
		{
			get{ return (list as ICollection<T>).Count; }
		}
		
		bool ICollection<T>.IsReadOnly
		{
			get{ return (list as ICollection<T>).IsReadOnly; }
		}
		
		void ICollection<T>.Add(T item)
		{
			(list as ICollection<T>).Add(item);
		}
		
		void ICollection<T>.Clear()
		{
			(list as ICollection<T>).Clear();
		}
		
		bool ICollection<T>.Contains(T item)
		{
			return (list as ICollection<T>).Contains(item);
		}
		
		void ICollection<T>.CopyTo(T[] array, int arrayIndex)
		{
			(list as ICollection<T>).CopyTo(array, arrayIndex);
		}
		
		bool ICollection<T>.Remove(T item)
		{
			return (list as ICollection<T>).Remove(item);
		}
		
		
		T IList<T>.this[int index]
		{
			get{ return (list as IList<T>)[index]; }
			set{ (list as IList<T>)[index] = value; }
		}
		
		int IList<T>.IndexOf(T item)
		{
			return (list as IList<T>).IndexOf(item);
		}
		
		void IList<T>.Insert(int index, T item)
		{
			(list as IList<T>).Insert(index, item);
		}
		
		void IList<T>.RemoveAt(int index)
		{
			(list as IList<T>).RemoveAt(index);
		}
	}
}