using System;
using System.Windows.Forms;
using System.Drawing;
using System.Windows.Forms.Layout;
using System.ComponentModel;
using System.Runtime.Remoting;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Collections;

namespace Sample2
{
	public class ControlDictionary<TKey, TValue>
		: IDictionary<TKey, TValue>, ICollection<KeyValuePair<TKey, TValue>>, IEnumerable<KeyValuePair<TKey, TValue>>, IEnumerable
		, IControlDic<TKey, TValue>
	{
		private PublicControl ctl;
		private Dictionary<TKey, TValue> dic;
		
		public ControlDictionary(PublicControl ctl, Dictionary<TKey, TValue> dic)
		{
			this.ctl = ctl;
			this.dic = dic;
		}
		
		
		public string AccessibleDefaultActionDescription
		{
			get{ return ctl.AccessibleDefaultActionDescription; }
			set{ ctl.AccessibleDefaultActionDescription = value; }
		}
		
		public string AccessibleDescription
		{
			get{ return ctl.AccessibleDescription; }
			set{ ctl.AccessibleDescription = value; }
		}
		
		public string AccessibleName
		{
			get{ return ctl.AccessibleName; }
			set{ ctl.AccessibleName = value; }
		}
		
		public AccessibleRole AccessibleRole
		{
			get{ return ctl.AccessibleRole; }
			set{ ctl.AccessibleRole = value; }
		}
		
		public virtual bool AllowDrop
		{
			get{ return ctl.AllowDrop; }
			set{ ctl.AllowDrop = value; }
		}
		
		public virtual AnchorStyles Anchor
		{
			get{ return ctl.Anchor; }
			set{ ctl.Anchor = value; }
		}
		
		public virtual bool AutoSize
		{
			get{ return ctl.AutoSize; }
			set{ ctl.AutoSize = value; }
		}
		
		public virtual Point AutoScrollOffset
		{
			get{ return ctl.AutoScrollOffset; }
			set{ ctl.AutoScrollOffset = value; }
		}
		
		public virtual LayoutEngine LayoutEngine
		{
			get{ return ctl.LayoutEngine; }
		}
		
		public virtual Color BackColor
		{
			get{ return ctl.BackColor; }
			set{ ctl.BackColor = value; }
		}
		
		public virtual Image BackgroundImage
		{
			get{ return ctl.BackgroundImage; }
			set{ ctl.BackgroundImage = value; }
		}
		
		public virtual ImageLayout BackgroundImageLayout
		{
			get{ return ctl.BackgroundImageLayout; }
			set{ ctl.BackgroundImageLayout = value; }
		}
		
		public virtual BindingContext BindingContext
		{
			get{ return ctl.BindingContext; }
			set{ ctl.BindingContext = value; }
		}
		
		public int Bottom
		{
			get{ return ctl.Bottom; }
		}
		
		public virtual Rectangle Bounds
		{
			get{ return ctl.Bounds; }
			set{ ctl.Bounds = value; }
		}
		
		public bool CanFocus
		{
			get{ return ctl.CanFocus; }
		}
		
		protected virtual bool CanRaiseEvents
		{
			get{ return ctl.CanRaiseEvents; }
		}
		
		public bool CanSelect
		{
			get{ return ctl.CanSelect; }
		}
		
		public bool Capture
		{
			get{ return ctl.Capture; }
			set{ ctl.Capture = value; }
		}
		
		public bool CausesValidation
		{
			get{ return ctl.CausesValidation; }
			set{ ctl.CausesValidation = value; }
		}
		
		public Rectangle ClientRectangle
		{
			get{ return ctl.ClientRectangle; }
		}
		
		public Size ClientSize
		{
			get{ return ctl.ClientSize; }
			set{ ctl.ClientSize = value; }
		}
		
		public string CompanyName
		{
			get{ return ctl.CompanyName; }
		}
		
		public bool ContainsFocus
		{
			get{ return ctl.ContainsFocus; }
		}
		
		public virtual ContextMenu ContextMenu
		{
			get{ return ctl.ContextMenu; }
			set{ ctl.ContextMenu = value; }
		}
		
		public virtual ContextMenuStrip ContextMenuStrip
		{
			get{ return ctl.ContextMenuStrip; }
			set{ ctl.ContextMenuStrip = value; }
		}
		
		public Control.ControlCollection Controls
		{
			get{ return ctl.Controls; }
		}
		
		public bool Created
		{
			get{ return ctl.Created; }
		}
		
		protected virtual CreateParams CreateParams
		{
			get{ return ctl.CreateParams; }
		}
		
		public virtual Cursor Cursor
		{
			get{ return ctl.Cursor; }
			set{ ctl.Cursor = value; }
		}
		
		public virtual ControlBindingsCollection DataBindings
		{
			get{ return ctl.DataBindings; }
		}
		
		protected virtual Cursor DefaultCursor
		{
			get{ return ctl.DefaultCursor; }
		}
		
		protected virtual Padding DefaultMargin
		{
			get{ return ctl.DefaultMargin; }
		}
		
		protected virtual Size DefaultMaximumSize
		{
			get{ return ctl.DefaultMaximumSize; }
		}
		
		protected virtual Size DefaultMinimumSize
		{
			get{ return ctl.DefaultMinimumSize; }
		}
		
		protected virtual Padding DefaultPadding
		{
			get{ return ctl.DefaultPadding; }
		}
		
		protected virtual Size DefaultSize
		{
			get{ return ctl.DefaultSize; }
		}
		
		public virtual Rectangle DisplayRectangle
		{
			get{ return ctl.DisplayRectangle; }
		}
		
		public bool IsDisposed
		{
			get{ return ctl.IsDisposed; }
		}
		
		public bool Disposing
		{
			get{ return ctl.Disposing; }
		}
		
		public virtual DockStyle Dock
		{
			get{ return ctl.Dock; }
			set{ ctl.Dock = value; }
		}
		
		protected virtual bool DoubleBuffered
		{
			get{ return ctl.DoubleBuffered; }
			set{ ctl.DoubleBuffered = value; }
		}
		
		public bool Enabled
		{
			get{ return ctl.Enabled; }
			set{ ctl.Enabled = value; }
		}
		
		public virtual bool Focused
		{
			get{ return ctl.Focused; }
		}
		
		public virtual Font Font
		{
			get{ return ctl.Font; }
			set{ ctl.Font = value; }
		}
		
		protected int FontHeight
		{
			get{ return ctl.FontHeight; }
			set{ ctl.FontHeight = value; }
		}
		
		public virtual Color ForeColor
		{
			get{ return ctl.ForeColor; }
			set{ ctl.ForeColor = value; }
		}
		
		public virtual IntPtr Handle
		{
			get{ return ctl.Handle; }
		}
		
		public bool HasChildren
		{
			get{ return ctl.HasChildren; }
		}
		
		public int Height
		{
			get{ return ctl.Height; }
			set{ ctl.Height = value; }
		}
		
		public bool IsHandleCreated
		{
			get{ return ctl.IsHandleCreated; }
		}
		
		public virtual bool InvokeRequired
		{
			get{ return ctl.InvokeRequired; }
		}
		
		public bool IsAccessible
		{
			get{ return ctl.IsAccessible; }
			set{ ctl.IsAccessible = value; }
		}
		
		public bool IsMirrored
		{
			get{ return ctl.IsMirrored; }
		}
		
		public int Left
		{
			get{ return ctl.Left; }
			set{ ctl.Left = value; }
		}
		
		public Point Location
		{
			get{ return ctl.Location; }
			set{ ctl.Location = value; }
		}
		
		public Padding Margin
		{
			get{ return ctl.Margin; }
			set{ ctl.Margin = value; }
		}
		
		public virtual Size MaximumSize
		{
			get{ return ctl.MaximumSize; }
			set{ ctl.MaximumSize = value; }
		}
		
		public virtual Size MinimumSize
		{
			get{ return ctl.MinimumSize; }
			set{ ctl.MinimumSize = value; }
		}
		
		public string Name
		{
			get{ return ctl.Name; }
			set{ ctl.Name = value; }
		}
		
		public Control Parent
		{
			get{ return ctl.Parent; }
			set{ ctl.Parent = value; }
		}
		
		public string ProductName
		{
			get{ return ctl.ProductName; }
		}
		
		public string ProductVersion
		{
			get{ return ctl.ProductVersion; }
		}
		
		public bool RecreatingHandle
		{
			get{ return ctl.RecreatingHandle; }
		}
		
		public Region Region
		{
			get{ return ctl.Region; }
			set{ ctl.Region = value; }
		}
		
		protected bool ResizeRedraw
		{
			get{ return ctl.ResizeRedraw; }
			set{ ctl.ResizeRedraw = value; }
		}
		
		public int Right
		{
			get{ return ctl.Right; }
		}
		
		public virtual RightToLeft RightToLeft
		{
			get{ return ctl.RightToLeft; }
			set{ ctl.RightToLeft = value; }
		}
		
		protected virtual bool ScaleChildren
		{
			get{ return ctl.ScaleChildren; }
		}
		
		public virtual ISite Site
		{
			get{ return ctl.Site; }
			set{ ctl.Site = value; }
		}
		
		public Size Size
		{
			get{ return ctl.Size; }
			set{ ctl.Size = value; }
		}
		
		public int TabIndex
		{
			get{ return ctl.TabIndex; }
			set{ ctl.TabIndex = value; }
		}
		
		public bool TabStop
		{
			get{ return ctl.TabStop; }
			set{ ctl.TabStop = value; }
		}
		
		public object Tag
		{
			get{ return ctl.Tag; }
			set{ ctl.Tag = value; }
		}
		
		public virtual string Text
		{
			get{ return ctl.Text; }
			set{ ctl.Text = value; }
		}
		
		public int Top
		{
			get{ return ctl.Top; }
			set{ ctl.Top = value; }
		}
		
		public Control TopLevelControl
		{
			get{ return ctl.TopLevelControl; }
		}
		
		protected internal virtual bool ShowKeyboardCues
		{
			get{ return ctl.ShowKeyboardCues; }
		}
		
		protected internal virtual bool ShowFocusCues
		{
			get{ return ctl.ShowFocusCues; }
		}
		
		public bool UseWaitCursor
		{
			get{ return ctl.UseWaitCursor; }
			set{ ctl.UseWaitCursor = value; }
		}
		
		public bool Visible
		{
			get{ return ctl.Visible; }
			set{ ctl.Visible = value; }
		}
		
		public int Width
		{
			get{ return ctl.Width; }
			set{ ctl.Width = value; }
		}
		
		public IWindowTarget WindowTarget
		{
			get{ return ctl.WindowTarget; }
			set{ ctl.WindowTarget = value; }
		}
		
		public Size PreferredSize
		{
			get{ return ctl.PreferredSize; }
		}
		
		public Padding Padding
		{
			get{ return ctl.Padding; }
			set{ ctl.Padding = value; }
		}
		
		protected virtual bool CanEnableIme
		{
			get{ return ctl.CanEnableIme; }
		}
		
		protected virtual ImeMode DefaultImeMode
		{
			get{ return ctl.DefaultImeMode; }
		}
		
		public ImeMode ImeMode
		{
			get{ return ctl.ImeMode; }
			set{ ctl.ImeMode = value; }
		}
		
		protected virtual ImeMode ImeModeBase
		{
			get{ return ctl.ImeModeBase; }
			set{ ctl.ImeModeBase = value; }
		}
		
		protected EventHandlerList Events
		{
			get{ return ctl.Events; }
		}
		
		public IContainer Container
		{
			get{ return ctl.Container; }
		}
		
		protected bool DesignMode
		{
			get{ return ctl.DesignMode; }
		}
		
		public event EventHandler AutoSizeChanged
		{
			add{ ctl.AutoSizeChanged += value; }
			remove{ ctl.AutoSizeChanged -= value; }
		}
		
		public event EventHandler BackColorChanged
		{
			add{ ctl.BackColorChanged += value; }
			remove{ ctl.BackColorChanged -= value; }
		}
		
		public event EventHandler BackgroundImageChanged
		{
			add{ ctl.BackgroundImageChanged += value; }
			remove{ ctl.BackgroundImageChanged -= value; }
		}
		
		public event EventHandler BackgroundImageLayoutChanged
		{
			add{ ctl.BackgroundImageLayoutChanged += value; }
			remove{ ctl.BackgroundImageLayoutChanged -= value; }
		}
		
		public event EventHandler BindingContextChanged
		{
			add{ ctl.BindingContextChanged += value; }
			remove{ ctl.BindingContextChanged -= value; }
		}
		
		public event EventHandler CausesValidationChanged
		{
			add{ ctl.CausesValidationChanged += value; }
			remove{ ctl.CausesValidationChanged -= value; }
		}
		
		public event EventHandler ClientSizeChanged
		{
			add{ ctl.ClientSizeChanged += value; }
			remove{ ctl.ClientSizeChanged -= value; }
		}
		
		public event EventHandler ContextMenuChanged
		{
			add{ ctl.ContextMenuChanged += value; }
			remove{ ctl.ContextMenuChanged -= value; }
		}
		
		public event EventHandler ContextMenuStripChanged
		{
			add{ ctl.ContextMenuStripChanged += value; }
			remove{ ctl.ContextMenuStripChanged -= value; }
		}
		
		public event EventHandler CursorChanged
		{
			add{ ctl.CursorChanged += value; }
			remove{ ctl.CursorChanged -= value; }
		}
		
		public event EventHandler DockChanged
		{
			add{ ctl.DockChanged += value; }
			remove{ ctl.DockChanged -= value; }
		}
		
		public event EventHandler EnabledChanged
		{
			add{ ctl.EnabledChanged += value; }
			remove{ ctl.EnabledChanged -= value; }
		}
		
		public event EventHandler FontChanged
		{
			add{ ctl.FontChanged += value; }
			remove{ ctl.FontChanged -= value; }
		}
		
		public event EventHandler ForeColorChanged
		{
			add{ ctl.ForeColorChanged += value; }
			remove{ ctl.ForeColorChanged -= value; }
		}
		
		public event EventHandler LocationChanged
		{
			add{ ctl.LocationChanged += value; }
			remove{ ctl.LocationChanged -= value; }
		}
		
		public event EventHandler MarginChanged
		{
			add{ ctl.MarginChanged += value; }
			remove{ ctl.MarginChanged -= value; }
		}
		
		public event EventHandler RegionChanged
		{
			add{ ctl.RegionChanged += value; }
			remove{ ctl.RegionChanged -= value; }
		}
		
		public event EventHandler RightToLeftChanged
		{
			add{ ctl.RightToLeftChanged += value; }
			remove{ ctl.RightToLeftChanged -= value; }
		}
		
		public event EventHandler SizeChanged
		{
			add{ ctl.SizeChanged += value; }
			remove{ ctl.SizeChanged -= value; }
		}
		
		public event EventHandler TabIndexChanged
		{
			add{ ctl.TabIndexChanged += value; }
			remove{ ctl.TabIndexChanged -= value; }
		}
		
		public event EventHandler TabStopChanged
		{
			add{ ctl.TabStopChanged += value; }
			remove{ ctl.TabStopChanged -= value; }
		}
		
		public event EventHandler TextChanged
		{
			add{ ctl.TextChanged += value; }
			remove{ ctl.TextChanged -= value; }
		}
		
		public event EventHandler VisibleChanged
		{
			add{ ctl.VisibleChanged += value; }
			remove{ ctl.VisibleChanged -= value; }
		}
		
		public event EventHandler Click
		{
			add{ ctl.Click += value; }
			remove{ ctl.Click -= value; }
		}
		
		public event ControlEventHandler ControlAdded
		{
			add{ ctl.ControlAdded += value; }
			remove{ ctl.ControlAdded -= value; }
		}
		
		public event ControlEventHandler ControlRemoved
		{
			add{ ctl.ControlRemoved += value; }
			remove{ ctl.ControlRemoved -= value; }
		}
		
		public event DragEventHandler DragDrop
		{
			add{ ctl.DragDrop += value; }
			remove{ ctl.DragDrop -= value; }
		}
		
		public event DragEventHandler DragEnter
		{
			add{ ctl.DragEnter += value; }
			remove{ ctl.DragEnter -= value; }
		}
		
		public event DragEventHandler DragOver
		{
			add{ ctl.DragOver += value; }
			remove{ ctl.DragOver -= value; }
		}
		
		public event EventHandler DragLeave
		{
			add{ ctl.DragLeave += value; }
			remove{ ctl.DragLeave -= value; }
		}
		
		public event GiveFeedbackEventHandler GiveFeedback
		{
			add{ ctl.GiveFeedback += value; }
			remove{ ctl.GiveFeedback -= value; }
		}
		
		public event EventHandler HandleCreated
		{
			add{ ctl.HandleCreated += value; }
			remove{ ctl.HandleCreated -= value; }
		}
		
		public event EventHandler HandleDestroyed
		{
			add{ ctl.HandleDestroyed += value; }
			remove{ ctl.HandleDestroyed -= value; }
		}
		
		public event HelpEventHandler HelpRequested
		{
			add{ ctl.HelpRequested += value; }
			remove{ ctl.HelpRequested -= value; }
		}
		
		public event InvalidateEventHandler Invalidated
		{
			add{ ctl.Invalidated += value; }
			remove{ ctl.Invalidated -= value; }
		}
		
		public event EventHandler PaddingChanged
		{
			add{ ctl.PaddingChanged += value; }
			remove{ ctl.PaddingChanged -= value; }
		}
		
		public event PaintEventHandler Paint
		{
			add{ ctl.Paint += value; }
			remove{ ctl.Paint -= value; }
		}
		
		public event QueryContinueDragEventHandler QueryContinueDrag
		{
			add{ ctl.QueryContinueDrag += value; }
			remove{ ctl.QueryContinueDrag -= value; }
		}
		
		public event QueryAccessibilityHelpEventHandler QueryAccessibilityHelp
		{
			add{ ctl.QueryAccessibilityHelp += value; }
			remove{ ctl.QueryAccessibilityHelp -= value; }
		}
		
		public event EventHandler DoubleClick
		{
			add{ ctl.DoubleClick += value; }
			remove{ ctl.DoubleClick -= value; }
		}
		
		public event EventHandler Enter
		{
			add{ ctl.Enter += value; }
			remove{ ctl.Enter -= value; }
		}
		
		public event EventHandler GotFocus
		{
			add{ ctl.GotFocus += value; }
			remove{ ctl.GotFocus -= value; }
		}
		
		public event KeyEventHandler KeyDown
		{
			add{ ctl.KeyDown += value; }
			remove{ ctl.KeyDown -= value; }
		}
		
		public event KeyPressEventHandler KeyPress
		{
			add{ ctl.KeyPress += value; }
			remove{ ctl.KeyPress -= value; }
		}
		
		public event KeyEventHandler KeyUp
		{
			add{ ctl.KeyUp += value; }
			remove{ ctl.KeyUp -= value; }
		}
		
		public event LayoutEventHandler Layout
		{
			add{ ctl.Layout += value; }
			remove{ ctl.Layout -= value; }
		}
		
		public event EventHandler Leave
		{
			add{ ctl.Leave += value; }
			remove{ ctl.Leave -= value; }
		}
		
		public event EventHandler LostFocus
		{
			add{ ctl.LostFocus += value; }
			remove{ ctl.LostFocus -= value; }
		}
		
		public event MouseEventHandler MouseClick
		{
			add{ ctl.MouseClick += value; }
			remove{ ctl.MouseClick -= value; }
		}
		
		public event MouseEventHandler MouseDoubleClick
		{
			add{ ctl.MouseDoubleClick += value; }
			remove{ ctl.MouseDoubleClick -= value; }
		}
		
		public event EventHandler MouseCaptureChanged
		{
			add{ ctl.MouseCaptureChanged += value; }
			remove{ ctl.MouseCaptureChanged -= value; }
		}
		
		public event MouseEventHandler MouseDown
		{
			add{ ctl.MouseDown += value; }
			remove{ ctl.MouseDown -= value; }
		}
		
		public event EventHandler MouseEnter
		{
			add{ ctl.MouseEnter += value; }
			remove{ ctl.MouseEnter -= value; }
		}
		
		public event EventHandler MouseLeave
		{
			add{ ctl.MouseLeave += value; }
			remove{ ctl.MouseLeave -= value; }
		}
		
		public event EventHandler MouseHover
		{
			add{ ctl.MouseHover += value; }
			remove{ ctl.MouseHover -= value; }
		}
		
		public event MouseEventHandler MouseMove
		{
			add{ ctl.MouseMove += value; }
			remove{ ctl.MouseMove -= value; }
		}
		
		public event MouseEventHandler MouseUp
		{
			add{ ctl.MouseUp += value; }
			remove{ ctl.MouseUp -= value; }
		}
		
		public event MouseEventHandler MouseWheel
		{
			add{ ctl.MouseWheel += value; }
			remove{ ctl.MouseWheel -= value; }
		}
		
		public event EventHandler Move
		{
			add{ ctl.Move += value; }
			remove{ ctl.Move -= value; }
		}
		
		public event PreviewKeyDownEventHandler PreviewKeyDown
		{
			add{ ctl.PreviewKeyDown += value; }
			remove{ ctl.PreviewKeyDown -= value; }
		}
		
		public event EventHandler Resize
		{
			add{ ctl.Resize += value; }
			remove{ ctl.Resize -= value; }
		}
		
		public event UICuesEventHandler ChangeUICues
		{
			add{ ctl.ChangeUICues += value; }
			remove{ ctl.ChangeUICues -= value; }
		}
		
		public event EventHandler StyleChanged
		{
			add{ ctl.StyleChanged += value; }
			remove{ ctl.StyleChanged -= value; }
		}
		
		public event EventHandler SystemColorsChanged
		{
			add{ ctl.SystemColorsChanged += value; }
			remove{ ctl.SystemColorsChanged -= value; }
		}
		
		public event CancelEventHandler Validating
		{
			add{ ctl.Validating += value; }
			remove{ ctl.Validating -= value; }
		}
		
		public event EventHandler Validated
		{
			add{ ctl.Validated += value; }
			remove{ ctl.Validated -= value; }
		}
		
		public event EventHandler ParentChanged
		{
			add{ ctl.ParentChanged += value; }
			remove{ ctl.ParentChanged -= value; }
		}
		
		public event EventHandler ImeModeChanged
		{
			add{ ctl.ImeModeChanged += value; }
			remove{ ctl.ImeModeChanged -= value; }
		}
		
		public virtual event EventHandler Disposed
		{
			add{ ctl.Disposed += value; }
			remove{ ctl.Disposed -= value; }
		}
		
		protected void SetAutoSizeMode(AutoSizeMode mode)
		{
			ctl.SetAutoSizeMode(mode);
		}
		
		protected AutoSizeMode GetAutoSizeMode()
		{
			return ctl.GetAutoSizeMode();
		}
		
		public void ResetBindings()
		{
			ctl.ResetBindings();
		}
		
		public virtual Size GetPreferredSize(Size proposedSize)
		{
			return ctl.GetPreferredSize(proposedSize);
		}
		
		protected internal void AccessibilityNotifyClients(AccessibleEvents accEvent, int childID)
		{
			ctl.AccessibilityNotifyClients(accEvent, childID);
		}
		
		protected void AccessibilityNotifyClients(AccessibleEvents accEvent, int objectID, int childID)
		{
			ctl.AccessibilityNotifyClients(accEvent, objectID, childID);
		}
		
		public IAsyncResult BeginInvoke(Delegate method)
		{
			return ctl.BeginInvoke(method);
		}
		
		public virtual IAsyncResult BeginInvoke(Delegate method, object[] args)
		{
			return ctl.BeginInvoke(method, args);
		}
		
		public void BringToFront()
		{
			ctl.BringToFront();
		}
		
		public bool Contains(Control ctl)
		{
			return ctl.Contains(ctl);
		}
		
		protected virtual Control.ControlCollection CreateControlsInstance()
		{
			return ctl.CreateControlsInstance();
		}
		
		public Graphics CreateGraphics()
		{
			return ctl.CreateGraphics();
		}
		
		protected virtual void CreateHandle()
		{
			ctl.CreateHandle();
		}
		
		public void CreateControl()
		{
			ctl.CreateControl();
		}
		
		protected virtual void DefWndProc(ref Message m)
		{
			ctl.DefWndProc(ref m);
		}
		
		protected virtual void DestroyHandle()
		{
			ctl.DestroyHandle();
		}
		
		protected virtual void Dispose(bool disposing)
		{
			ctl.Dispose(disposing);
		}
		
		public DragDropEffects DoDragDrop(object data, DragDropEffects allowedEffects)
		{
			return ctl.DoDragDrop(data, allowedEffects);
		}
		
		public void DrawToBitmap(Bitmap bitmap, Rectangle targetBounds)
		{
			ctl.DrawToBitmap(bitmap, targetBounds);
		}
		
		public virtual object EndInvoke(IAsyncResult asyncResult)
		{
			return ctl.EndInvoke(asyncResult);
		}
		
		public Form FindForm()
		{
			return ctl.FindForm();
		}
		
		protected bool GetTopLevel()
		{
			return ctl.GetTopLevel();
		}
		
		protected void RaiseKeyEvent(object key, KeyEventArgs e)
		{
			ctl.RaiseKeyEvent(key, e);
		}
		
		protected void RaiseMouseEvent(object key, MouseEventArgs e)
		{
			ctl.RaiseMouseEvent(key, e);
		}
		
		public bool Focus()
		{
			return ctl.Focus();
		}
		
		public Control GetChildAtPoint(Point pt, GetChildAtPointSkip skipValue)
		{
			return ctl.GetChildAtPoint(pt, skipValue);
		}
		
		public Control GetChildAtPoint(Point pt)
		{
			return ctl.GetChildAtPoint(pt);
		}
		
		public IContainerControl GetContainerControl()
		{
			return ctl.GetContainerControl();
		}
		
		protected virtual Rectangle GetScaledBounds(Rectangle bounds, SizeF factor, BoundsSpecified specified)
		{
			return ctl.GetScaledBounds(bounds, factor, specified);
		}
		
		public Control GetNextControl(Control ctl, bool forward)
		{
			return ctl.GetNextControl(ctl, forward);
		}
		
		protected bool GetStyle(ControlStyles flag)
		{
			return ctl.GetStyle(flag);
		}
		
		public void Hide()
		{
			ctl.Hide();
		}
		
		protected virtual void InitLayout()
		{
			ctl.InitLayout();
		}
		
		public void Invalidate(Region region)
		{
			ctl.Invalidate(region);
		}
		
		public void Invalidate(Region region, bool invalidateChildren)
		{
			ctl.Invalidate(region, invalidateChildren);
		}
		
		public void Invalidate()
		{
			ctl.Invalidate();
		}
		
		public void Invalidate(bool invalidateChildren)
		{
			ctl.Invalidate(invalidateChildren);
		}
		
		public void Invalidate(Rectangle rc)
		{
			ctl.Invalidate(rc);
		}
		
		public void Invalidate(Rectangle rc, bool invalidateChildren)
		{
			ctl.Invalidate(rc, invalidateChildren);
		}
		
		public object Invoke(Delegate method)
		{
			return ctl.Invoke(method);
		}
		
		public virtual object Invoke(Delegate method, object[] args)
		{
			return ctl.Invoke(method, args);
		}
		
		protected void InvokePaint(Control c, PaintEventArgs e)
		{
			ctl.InvokePaint(c, e);
		}
		
		protected void InvokePaintBackground(Control c, PaintEventArgs e)
		{
			ctl.InvokePaintBackground(c, e);
		}
		
		protected virtual bool IsInputChar(char charCode)
		{
			return ctl.IsInputChar(charCode);
		}
		
		protected virtual bool IsInputKey(Keys keyData)
		{
			return ctl.IsInputKey(keyData);
		}
		
		protected virtual void NotifyInvalidate(Rectangle invalidatedArea)
		{
			ctl.NotifyInvalidate(invalidatedArea);
		}
		
		protected void InvokeOnClick(Control toInvoke, EventArgs e)
		{
			ctl.InvokeOnClick(toInvoke, e);
		}
		
		protected virtual void OnAutoSizeChanged(EventArgs e)
		{
			ctl.OnAutoSizeChanged(e);
		}
		
		protected virtual void OnBackColorChanged(EventArgs e)
		{
			ctl.OnBackColorChanged(e);
		}
		
		protected virtual void OnBackgroundImageChanged(EventArgs e)
		{
			ctl.OnBackgroundImageChanged(e);
		}
		
		protected virtual void OnBackgroundImageLayoutChanged(EventArgs e)
		{
			ctl.OnBackgroundImageLayoutChanged(e);
		}
		
		protected virtual void OnBindingContextChanged(EventArgs e)
		{
			ctl.OnBindingContextChanged(e);
		}
		
		protected virtual void OnCausesValidationChanged(EventArgs e)
		{
			ctl.OnCausesValidationChanged(e);
		}
		
		protected virtual void OnContextMenuChanged(EventArgs e)
		{
			ctl.OnContextMenuChanged(e);
		}
		
		protected virtual void OnContextMenuStripChanged(EventArgs e)
		{
			ctl.OnContextMenuStripChanged(e);
		}
		
		protected virtual void OnCursorChanged(EventArgs e)
		{
			ctl.OnCursorChanged(e);
		}
		
		protected virtual void OnDockChanged(EventArgs e)
		{
			ctl.OnDockChanged(e);
		}
		
		protected virtual void OnEnabledChanged(EventArgs e)
		{
			ctl.OnEnabledChanged(e);
		}
		
		protected virtual void OnFontChanged(EventArgs e)
		{
			ctl.OnFontChanged(e);
		}
		
		protected virtual void OnForeColorChanged(EventArgs e)
		{
			ctl.OnForeColorChanged(e);
		}
		
		protected virtual void OnRightToLeftChanged(EventArgs e)
		{
			ctl.OnRightToLeftChanged(e);
		}
		
		protected virtual void OnNotifyMessage(Message m)
		{
			ctl.OnNotifyMessage(m);
		}
		
		protected virtual void OnParentBackColorChanged(EventArgs e)
		{
			ctl.OnParentBackColorChanged(e);
		}
		
		protected virtual void OnParentBackgroundImageChanged(EventArgs e)
		{
			ctl.OnParentBackgroundImageChanged(e);
		}
		
		protected virtual void OnParentBindingContextChanged(EventArgs e)
		{
			ctl.OnParentBindingContextChanged(e);
		}
		
		protected virtual void OnParentCursorChanged(EventArgs e)
		{
			ctl.OnParentCursorChanged(e);
		}
		
		protected virtual void OnParentEnabledChanged(EventArgs e)
		{
			ctl.OnParentEnabledChanged(e);
		}
		
		protected virtual void OnParentFontChanged(EventArgs e)
		{
			ctl.OnParentFontChanged(e);
		}
		
		protected virtual void OnParentForeColorChanged(EventArgs e)
		{
			ctl.OnParentForeColorChanged(e);
		}
		
		protected virtual void OnParentRightToLeftChanged(EventArgs e)
		{
			ctl.OnParentRightToLeftChanged(e);
		}
		
		protected virtual void OnParentVisibleChanged(EventArgs e)
		{
			ctl.OnParentVisibleChanged(e);
		}
		
		protected virtual void OnPrint(PaintEventArgs e)
		{
			ctl.OnPrint(e);
		}
		
		protected virtual void OnTabIndexChanged(EventArgs e)
		{
			ctl.OnTabIndexChanged(e);
		}
		
		protected virtual void OnTabStopChanged(EventArgs e)
		{
			ctl.OnTabStopChanged(e);
		}
		
		protected virtual void OnTextChanged(EventArgs e)
		{
			ctl.OnTextChanged(e);
		}
		
		protected virtual void OnVisibleChanged(EventArgs e)
		{
			ctl.OnVisibleChanged(e);
		}
		
		protected virtual void OnParentChanged(EventArgs e)
		{
			ctl.OnParentChanged(e);
		}
		
		protected virtual void OnClick(EventArgs e)
		{
			ctl.OnClick(e);
		}
		
		protected virtual void OnClientSizeChanged(EventArgs e)
		{
			ctl.OnClientSizeChanged(e);
		}
		
		protected virtual void OnControlAdded(ControlEventArgs e)
		{
			ctl.OnControlAdded(e);
		}
		
		protected virtual void OnControlRemoved(ControlEventArgs e)
		{
			ctl.OnControlRemoved(e);
		}
		
		protected virtual void OnCreateControl()
		{
			ctl.OnCreateControl();
		}
		
		protected virtual void OnHandleCreated(EventArgs e)
		{
			ctl.OnHandleCreated(e);
		}
		
		protected virtual void OnLocationChanged(EventArgs e)
		{
			ctl.OnLocationChanged(e);
		}
		
		protected virtual void OnHandleDestroyed(EventArgs e)
		{
			ctl.OnHandleDestroyed(e);
		}
		
		protected virtual void OnDoubleClick(EventArgs e)
		{
			ctl.OnDoubleClick(e);
		}
		
		protected virtual void OnDragEnter(DragEventArgs drgevent)
		{
			ctl.OnDragEnter(drgevent);
		}
		
		protected virtual void OnDragOver(DragEventArgs drgevent)
		{
			ctl.OnDragOver(drgevent);
		}
		
		protected virtual void OnDragLeave(EventArgs e)
		{
			ctl.OnDragLeave(e);
		}
		
		protected virtual void OnDragDrop(DragEventArgs drgevent)
		{
			ctl.OnDragDrop(drgevent);
		}
		
		protected virtual void OnGiveFeedback(GiveFeedbackEventArgs gfbevent)
		{
			ctl.OnGiveFeedback(gfbevent);
		}
		
		protected virtual void OnEnter(EventArgs e)
		{
			ctl.OnEnter(e);
		}
		
		protected void InvokeGotFocus(Control toInvoke, EventArgs e)
		{
			ctl.InvokeGotFocus(toInvoke, e);
		}
		
		protected virtual void OnGotFocus(EventArgs e)
		{
			ctl.OnGotFocus(e);
		}
		
		protected virtual void OnHelpRequested(HelpEventArgs hevent)
		{
			ctl.OnHelpRequested(hevent);
		}
		
		protected virtual void OnInvalidated(InvalidateEventArgs e)
		{
			ctl.OnInvalidated(e);
		}
		
		protected virtual void OnKeyDown(KeyEventArgs e)
		{
			ctl.OnKeyDown(e);
		}
		
		protected virtual void OnKeyPress(KeyPressEventArgs e)
		{
			ctl.OnKeyPress(e);
		}
		
		protected virtual void OnKeyUp(KeyEventArgs e)
		{
			ctl.OnKeyUp(e);
		}
		
		protected virtual void OnLayout(LayoutEventArgs levent)
		{
			ctl.OnLayout(levent);
		}
		
		protected virtual void OnLeave(EventArgs e)
		{
			ctl.OnLeave(e);
		}
		
		protected void InvokeLostFocus(Control toInvoke, EventArgs e)
		{
			ctl.InvokeLostFocus(toInvoke, e);
		}
		
		protected virtual void OnLostFocus(EventArgs e)
		{
			ctl.OnLostFocus(e);
		}
		
		protected virtual void OnMarginChanged(EventArgs e)
		{
			ctl.OnMarginChanged(e);
		}
		
		protected virtual void OnMouseDoubleClick(MouseEventArgs e)
		{
			ctl.OnMouseDoubleClick(e);
		}
		
		protected virtual void OnMouseClick(MouseEventArgs e)
		{
			ctl.OnMouseClick(e);
		}
		
		protected virtual void OnMouseCaptureChanged(EventArgs e)
		{
			ctl.OnMouseCaptureChanged(e);
		}
		
		protected virtual void OnMouseDown(MouseEventArgs e)
		{
			ctl.OnMouseDown(e);
		}
		
		protected virtual void OnMouseEnter(EventArgs e)
		{
			ctl.OnMouseEnter(e);
		}
		
		protected virtual void OnMouseLeave(EventArgs e)
		{
			ctl.OnMouseLeave(e);
		}
		
		protected virtual void OnMouseHover(EventArgs e)
		{
			ctl.OnMouseHover(e);
		}
		
		protected virtual void OnMouseMove(MouseEventArgs e)
		{
			ctl.OnMouseMove(e);
		}
		
		protected virtual void OnMouseUp(MouseEventArgs e)
		{
			ctl.OnMouseUp(e);
		}
		
		protected virtual void OnMouseWheel(MouseEventArgs e)
		{
			ctl.OnMouseWheel(e);
		}
		
		protected virtual void OnMove(EventArgs e)
		{
			ctl.OnMove(e);
		}
		
		protected virtual void OnPaint(PaintEventArgs e)
		{
			ctl.OnPaint(e);
		}
		
		protected virtual void OnPaddingChanged(EventArgs e)
		{
			ctl.OnPaddingChanged(e);
		}
		
		protected virtual void OnPaintBackground(PaintEventArgs pevent)
		{
			ctl.OnPaintBackground(pevent);
		}
		
		protected virtual void OnQueryContinueDrag(QueryContinueDragEventArgs qcdevent)
		{
			ctl.OnQueryContinueDrag(qcdevent);
		}
		
		protected virtual void OnRegionChanged(EventArgs e)
		{
			ctl.OnRegionChanged(e);
		}
		
		protected virtual void OnResize(EventArgs e)
		{
			ctl.OnResize(e);
		}
		
		protected virtual void OnPreviewKeyDown(PreviewKeyDownEventArgs e)
		{
			ctl.OnPreviewKeyDown(e);
		}
		
		protected virtual void OnSizeChanged(EventArgs e)
		{
			ctl.OnSizeChanged(e);
		}
		
		protected virtual void OnChangeUICues(UICuesEventArgs e)
		{
			ctl.OnChangeUICues(e);
		}
		
		protected virtual void OnStyleChanged(EventArgs e)
		{
			ctl.OnStyleChanged(e);
		}
		
		protected virtual void OnSystemColorsChanged(EventArgs e)
		{
			ctl.OnSystemColorsChanged(e);
		}
		
		protected virtual void OnValidating(CancelEventArgs e)
		{
			ctl.OnValidating(e);
		}
		
		protected virtual void OnValidated(EventArgs e)
		{
			ctl.OnValidated(e);
		}
		
		public void PerformLayout()
		{
			ctl.PerformLayout();
		}
		
		public void PerformLayout(Control affectedControl, string affectedProperty)
		{
			ctl.PerformLayout(affectedControl, affectedProperty);
		}
		
		public Point PointToClient(Point p)
		{
			return ctl.PointToClient(p);
		}
		
		public Point PointToScreen(Point p)
		{
			return ctl.PointToScreen(p);
		}
		
		public virtual bool PreProcessMessage(ref Message msg)
		{
			return ctl.PreProcessMessage(ref msg);
		}
		
		public PreProcessControlState PreProcessControlMessage(ref Message msg)
		{
			return ctl.PreProcessControlMessage(ref msg);
		}
		
		protected virtual bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			return ctl.ProcessCmdKey(ref msg, keyData);
		}
		
		protected virtual bool ProcessDialogChar(char charCode)
		{
			return ctl.ProcessDialogChar(charCode);
		}
		
		protected virtual bool ProcessDialogKey(Keys keyData)
		{
			return ctl.ProcessDialogKey(keyData);
		}
		
		protected virtual bool ProcessKeyEventArgs(ref Message m)
		{
			return ctl.ProcessKeyEventArgs(ref m);
		}
		
		protected internal virtual bool ProcessKeyMessage(ref Message m)
		{
			return ctl.ProcessKeyMessage(ref m);
		}
		
		protected virtual bool ProcessKeyPreview(ref Message m)
		{
			return ctl.ProcessKeyPreview(ref m);
		}
		
		protected internal virtual bool ProcessMnemonic(char charCode)
		{
			return ctl.ProcessMnemonic(charCode);
		}
		
		protected void RaiseDragEvent(object key, DragEventArgs e)
		{
			ctl.RaiseDragEvent(key, e);
		}
		
		protected void RaisePaintEvent(object key, PaintEventArgs e)
		{
			ctl.RaisePaintEvent(key, e);
		}
		
		public virtual void ResetBackColor()
		{
			ctl.ResetBackColor();
		}
		
		public virtual void ResetCursor()
		{
			ctl.ResetCursor();
		}
		
		public virtual void ResetFont()
		{
			ctl.ResetFont();
		}
		
		public virtual void ResetForeColor()
		{
			ctl.ResetForeColor();
		}
		
		public virtual void ResetRightToLeft()
		{
			ctl.ResetRightToLeft();
		}
		
		protected void RecreateHandle()
		{
			ctl.RecreateHandle();
		}
		
		public Rectangle RectangleToClient(Rectangle r)
		{
			return ctl.RectangleToClient(r);
		}
		
		public Rectangle RectangleToScreen(Rectangle r)
		{
			return ctl.RectangleToScreen(r);
		}
		
		public virtual void Refresh()
		{
			ctl.Refresh();
		}
		
		protected void ResetMouseEventArgs()
		{
			ctl.ResetMouseEventArgs();
		}
		
		public virtual void ResetText()
		{
			ctl.ResetText();
		}
		
		public void ResumeLayout()
		{
			ctl.ResumeLayout();
		}
		
		public void ResumeLayout(bool performLayout)
		{
			ctl.ResumeLayout(performLayout);
		}
		
		protected virtual void ScaleControl(SizeF factor, BoundsSpecified specified)
		{
			ctl.ScaleControl(factor, specified);
		}
		
		protected virtual void ScaleCore(float dx, float dy)
		{
			ctl.ScaleCore(dx, dy);
		}
		
		public void Select()
		{
			ctl.Select();
		}
		
		protected virtual void Select(bool directed, bool forward)
		{
			ctl.Select(directed, forward);
		}
		
		public bool SelectNextControl(Control ctl, bool forward, bool tabStopOnly, bool nested, bool wrap)
		{
			return ctl.SelectNextControl(ctl, forward, tabStopOnly, nested, wrap);
		}
		
		public void SendToBack()
		{
			ctl.SendToBack();
		}
		
		public void SetBounds(int x, int y, int width, int height)
		{
			ctl.SetBounds(x, y, width, height);
		}
		
		public void SetBounds(int x, int y, int width, int height, BoundsSpecified specified)
		{
			ctl.SetBounds(x, y, width, height, specified);
		}
		
		protected virtual void SetBoundsCore(int x, int y, int width, int height, BoundsSpecified specified)
		{
			ctl.SetBoundsCore(x, y, width, height, specified);
		}
		
		protected virtual void SetClientSizeCore(int x, int y)
		{
			ctl.SetClientSizeCore(x, y);
		}
		
		protected virtual Size SizeFromClientSize(Size clientSize)
		{
			return ctl.SizeFromClientSize(clientSize);
		}
		
		protected void SetStyle(ControlStyles flag, bool value)
		{
			ctl.SetStyle(flag, value);
		}
		
		protected void SetTopLevel(bool value)
		{
			ctl.SetTopLevel(value);
		}
		
		protected virtual void SetVisibleCore(bool value)
		{
			ctl.SetVisibleCore(value);
		}
		
		protected HorizontalAlignment RtlTranslateAlignment(HorizontalAlignment align)
		{
			return ctl.RtlTranslateAlignment(align);
		}
		
		protected LeftRightAlignment RtlTranslateAlignment(LeftRightAlignment align)
		{
			return ctl.RtlTranslateAlignment(align);
		}
		
		protected ContentAlignment RtlTranslateAlignment(ContentAlignment align)
		{
			return ctl.RtlTranslateAlignment(align);
		}
		
		protected HorizontalAlignment RtlTranslateHorizontal(HorizontalAlignment align)
		{
			return ctl.RtlTranslateHorizontal(align);
		}
		
		protected LeftRightAlignment RtlTranslateLeftRight(LeftRightAlignment align)
		{
			return ctl.RtlTranslateLeftRight(align);
		}
		
		protected internal ContentAlignment RtlTranslateContent(ContentAlignment align)
		{
			return ctl.RtlTranslateContent(align);
		}
		
		public void Show()
		{
			ctl.Show();
		}
		
		public void SuspendLayout()
		{
			ctl.SuspendLayout();
		}
		
		public void Update()
		{
			ctl.Update();
		}
		
		protected internal void UpdateBounds()
		{
			ctl.UpdateBounds();
		}
		
		protected void UpdateBounds(int x, int y, int width, int height)
		{
			ctl.UpdateBounds(x, y, width, height);
		}
		
		protected void UpdateBounds(int x, int y, int width, int height, int clientWidth, int clientHeight)
		{
			ctl.UpdateBounds(x, y, width, height, clientWidth, clientHeight);
		}
		
		protected void UpdateZOrder()
		{
			ctl.UpdateZOrder();
		}
		
		protected void UpdateStyles()
		{
			ctl.UpdateStyles();
		}
		
		protected virtual void WndProc(ref Message m)
		{
			ctl.WndProc(ref m);
		}
		
		protected virtual void OnImeModeChanged(EventArgs e)
		{
			ctl.OnImeModeChanged(e);
		}
		
		public void ResetImeMode()
		{
			ctl.ResetImeMode();
		}
		
		public virtual void Dispose()
		{
			ctl.Dispose();
		}
		
		protected virtual object GetService(Type service)
		{
			return ctl.GetService(service);
		}
		
		protected MarshalByRefObject MemberwiseClone(bool cloneIdentity)
		{
			return ctl.MemberwiseClone(cloneIdentity);
		}
		
		public virtual object GetLifetimeService()
		{
			return ctl.GetLifetimeService();
		}
		
		public virtual object InitializeLifetimeService()
		{
			return ctl.InitializeLifetimeService();
		}
		
		public virtual ObjRef CreateObjRef(Type requestedType)
		{
			return ctl.CreateObjRef(requestedType);
		}
		public void Scale(SizeF factor)
		{
			ctl.Scale(factor);
		}
		
		
		public IEqualityComparer<TKey> Comparer
		{
			get{ return dic.Comparer; }
		}
		
		public int Count
		{
			get{ return dic.Count; }
		}
		
		public Dictionary<TKey, TValue>.KeyCollection Keys
		{
			get{ return dic.Keys; }
		}
		
		public Dictionary<TKey, TValue>.ValueCollection Values
		{
			get{ return dic.Values; }
		}
		
		public TValue this[TKey key]
		{
			get{ return dic[key]; }
			set{ dic[key] = value; }
		}
		
		public void Add(TKey key, TValue value)
		{
			dic.Add(key, value);
		}
		
		public void Clear()
		{
			dic.Clear();
		}
		
		public bool ContainsKey(TKey key)
		{
			return dic.ContainsKey(key);
		}
		
		public bool ContainsValue(TValue value)
		{
			return dic.ContainsValue(value);
		}
		
		public Dictionary<TKey, TValue>.Enumerator GetEnumerator()
		{
			return dic.GetEnumerator();
		}
		
		public void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			dic.GetObjectData(info, context);
		}
		
		public void OnDeserialization(object sender)
		{
			dic.OnDeserialization(sender);
		}
		
		public bool Remove(TKey key)
		{
			return dic.Remove(key);
		}
		
		public bool TryGetValue(TKey key, out TValue value)
		{
			return dic.TryGetValue(key, out value);
		}
		
		
		TValue IDictionary<TKey, TValue>.this[TKey key]
		{
			get{ return (dic as IDictionary<TKey, TValue>)[key]; }
			set{ (dic as IDictionary<TKey, TValue>)[key] = value; }
		}
		
		ICollection<TKey> IDictionary<TKey, TValue>.Keys
		{
			get{ return (dic as IDictionary<TKey, TValue>).Keys; }
		}
		
		ICollection<TValue> IDictionary<TKey, TValue>.Values
		{
			get{ return (dic as IDictionary<TKey, TValue>).Values; }
		}
		
		bool IDictionary<TKey, TValue>.ContainsKey(TKey key)
		{
			return (dic as IDictionary<TKey, TValue>).ContainsKey(key);
		}
		
		void IDictionary<TKey, TValue>.Add(TKey key, TValue value)
		{
			(dic as IDictionary<TKey, TValue>).Add(key, value);
		}
		
		bool IDictionary<TKey, TValue>.Remove(TKey key)
		{
			return (dic as IDictionary<TKey, TValue>).Remove(key);
		}
		
		bool IDictionary<TKey, TValue>.TryGetValue(TKey key, out TValue value)
		{
			return (dic as IDictionary<TKey, TValue>).TryGetValue(key, out value);
		}
		
		
		int ICollection<KeyValuePair<TKey, TValue>>.Count
		{
			get{ return (dic as ICollection<KeyValuePair<TKey,TValue>>).Count; }
		}
		
		bool ICollection<KeyValuePair<TKey, TValue>>.IsReadOnly
		{
			get{ return (dic as ICollection<KeyValuePair<TKey,TValue>>).IsReadOnly; }
		}
		
		void ICollection<KeyValuePair<TKey, TValue>>.Add(KeyValuePair<TKey, TValue> item)
		{
			(dic as ICollection<KeyValuePair<TKey,TValue>>).Add(item);
		}
		
		void ICollection<KeyValuePair<TKey, TValue>>.Clear()
		{
			(dic as ICollection<KeyValuePair<TKey,TValue>>).Clear();
		}
		
		bool ICollection<KeyValuePair<TKey, TValue>>.Contains(KeyValuePair<TKey, TValue> item)
		{
			return (dic as ICollection<KeyValuePair<TKey,TValue>>).Contains(item);
		}
		
		void ICollection<KeyValuePair<TKey, TValue>>.CopyTo(KeyValuePair<TKey, TValue>[] array, int arrayIndex)
		{
			(dic as ICollection<KeyValuePair<TKey,TValue>>).CopyTo(array, arrayIndex);
		}
		
		bool ICollection<KeyValuePair<TKey, TValue>>.Remove(KeyValuePair<TKey, TValue> item)
		{
			return (dic as ICollection<KeyValuePair<TKey,TValue>>).Remove(item);
		}
		
		
		IEnumerator<KeyValuePair<TKey, TValue>> IEnumerable<KeyValuePair<TKey, TValue>>.GetEnumerator()
		{
			return (dic as IEnumerable<KeyValuePair<TKey, TValue>>).GetEnumerator();
		}
		
		
		IEnumerator IEnumerable.GetEnumerator()
		{
			return (dic as IEnumerable).GetEnumerator();
		}
	}
}