﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using aSourceRewriter;
using aExtractInterface;
using aMultipleInheritance;
using SingletonObj = Sample3.SingletonObj;

namespace Sample3
{
	//適当なSingleton
	class SingletonObj
	{
		public readonly static SingletonObj Instance = new SingletonObj();

		private SingletonObj() { }

		public string Name { get; set; }
		public int Count { get; set; }
	}
}

namespace MultipleInheritanceTest
{
	class Sample3
	{
		public static void Do()
		{
			var sr = new zSourceRewriter("MultipleInheritance", "MultipleInheritanceTest\\GeneratedCode.cs");

			//シングルトンに簡単にアクセスできるようにするラッパーを作る
			var singletonSource = zMultipleInheritance.GetSourceCode(new zClassData
			{
				ClassName = "Singleton",
				NameSpace = "Sample3",
				HasConstructor = false,
				IsStatic = true
			}, new[]{
				new zInheriData{
					Type = typeof(SingletonObj),
					//委譲先の名前をシングルトンのインスタンスにする。
					//所詮テキスト置換機なのでコンパイルさえ通ればいい(通らなくてもいいかもしれない)
					Name = "SingletonObj.Instance",
					CreateField = false,
					IsStatic = true,
				}
			});

			sr.Write("Sample3_Singleton.cs", singletonSource);
		}
	}
}
