using System;
using System.Windows.Forms;
using System.Threading;
using System.ComponentModel;
using System.Runtime.Remoting;
using ThreadTimer = System.Threading.Timer;
using WinTimer = System.Windows.Forms.Timer;

namespace Sample5
{
	public partial class DoubleTimer
		: MarshalByRefObject, IComponent
	{
		private WinTimer WindowsTimer;
		private ThreadTimer ThreadTimer;
		
		public DoubleTimer(WinTimer windowsTimer, ThreadTimer threadTimer)
		{
			this.WindowsTimer = windowsTimer;
			this.ThreadTimer = threadTimer;
		}
		
		
		public object Tag
		{
			get{ return WindowsTimer.Tag; }
			set{ WindowsTimer.Tag = value; }
		}
		
		public bool Enabled
		{
			get{ return WindowsTimer.Enabled; }
			set{ WindowsTimer.Enabled = value; }
		}
		
		public int Interval
		{
			get{ return WindowsTimer.Interval; }
			set{ WindowsTimer.Interval = value; }
		}
		
		public ISite Site
		{
			get{ return WindowsTimer.Site; }
			set{ WindowsTimer.Site = value; }
		}
		
		public IContainer Container
		{
			get{ return WindowsTimer.Container; }
		}
		
		public event EventHandler Tick
		{
			add{ WindowsTimer.Tick += value; }
			remove{ WindowsTimer.Tick -= value; }
		}
		
		public event EventHandler Disposed
		{
			add{ WindowsTimer.Disposed += value; }
			remove{ WindowsTimer.Disposed -= value; }
		}
		
		public void Start()
		{
			WindowsTimer.Start();
		}
		
		public void Stop()
		{
			WindowsTimer.Stop();
		}
		
		
		public bool Change(int dueTime, int period)
		{
			return ThreadTimer.Change(dueTime, period);
		}
		
		public bool Change(TimeSpan dueTime, TimeSpan period)
		{
			return ThreadTimer.Change(dueTime, period);
		}
		
		public bool Change(uint dueTime, uint period)
		{
			return ThreadTimer.Change(dueTime, period);
		}
		
		public bool Change(long dueTime, long period)
		{
			return ThreadTimer.Change(dueTime, period);
		}
	}
}