﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using aSourceRewriter;
using aMultipleInheritance;

namespace MultipleInheritanceTest
{
	public class zMemberMapCreator
	{
		public static void Do()
		{
			var sr = new zSourceRewriter("MultipleInheritance", "MultipleInheritanceTest\\GeneratedCode.cs");

			var enu = new zInheriData
			{
				Type = typeof(System.Collections.IEnumerable),
				CreateField = false,
				Access = eAccess.InterfaceExplicit,
				Name = "(yDic as IEnumerable)"
			};

			string key = "string";
			//実際はFunc<zMemberData, zMemberData>だがそれだと可読性もへったくれもないコードになる
			string val = "FuncMM";


			var keyValPair = "KeyValuePair";

			Func<string, string> getName = type => "(yDic as " + type + "<" + keyValPair + ">)";

			var enu_t = new zInheriData
			{
				Type = typeof(IEnumerable<>),
				CreateField = false,
				Access = eAccess.InterfaceExplicit,
				Name = getName("IEnumerable")
			};

			enu_t.TypeNameMap.Add("T", keyValPair);

			var col = new zInheriData
			{
				Type = typeof(ICollection<>),
				CreateField = false,
				Access = eAccess.InterfaceExplicit,
				Name = getName("ICollection")
			};

			col.TypeNameMap.Add("T", keyValPair);

			var dic = new zInheriData
			{
				Type = typeof(IDictionary<,>),
				CreateField = false,
				IsDerived = true,
				Access = eAccess.InterfaceExplicit,
				Name = "(yDic as IDictionary<" + key + ", " + val + ">)"
			};

			dic.TypeNameMap.Add("TKey", key);
			dic.TypeNameMap.Add("TValue", val);

			var mainDic = new zInheriData
			{
				Type = typeof(Dictionary<,>),
				Name = "yDic",
				UseMember = false
			};
			

			mainDic.TypeNameMap.Add("TKey", key); 
			mainDic.TypeNameMap.Add("TValue", val);

			var memMapSource = zMultipleInheritance.GetSourceCode(new zClassData
			{
				ClassName = "zMemberMap_Generated",
				NameSpace = "aMultipleInheritance",
				Usings = new[] {
					"using System;", 
					"using System.Collections.Generic;", 
					"using System.Runtime.Serialization;",
					"using System.Collections;",
					"using FuncMM = System.Func<aMultipleInheritance.zMemberData, aMultipleInheritance.zMemberData>;",
					"using KeyValuePair = System.Collections.Generic.KeyValuePair<string,",
					"	System.Func<aMultipleInheritance.zMemberData, aMultipleInheritance.zMemberData>>;"
				},
				IsPartial = true,
				HasConstructor = false
			}, new[]{ mainDic, enu, enu_t, col, dic	});
			
			sr.Write(memMapSource);
		}
	}
}
