﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aBetween
{
	public static class zBetween
	{
		/// <summary>
		/// 最後を除いて変換する
		/// </summary>
		public static IEnumerable<T> Between<T>(this IEnumerable<T> e, Func<T, T> func)
		{
			object before = null;
			foreach (var item in e)
			{
				if (before != null)
					yield return func((T)before);

				before = item;
			}
			if (before != null)
				yield return (T)before;
		}

		/// <summary>
		/// 最後だけ別の変換をする
		/// </summary>
		public static IEnumerable<U> Between<T, U>(this IEnumerable<T> e, Func<T, U> between, Func<T, U> last)
		{
			object before = null;
			foreach (var item in e)
			{
				if (before != null)
					yield return between((T)before);

				before = item;
			}
			if (before != null)
				yield return last((T)before);
		}
	}
}
