﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.CSharp;
using System.Reflection;
using System.CodeDom.Compiler;

using System.IO;

namespace aCompiler
{
	public class zCompiler
	{
		public static Assembly Compile(string source, AppDomain domain)
		{
			return Compile(source, domain.GetAssemblies().Select(a => a.GetName()).ToArray());
		}

		public static Assembly Compile(string source, AssemblyName[] refAssemblies)
		{
			return Compile(source, refAssemblies.Select(a => a.Name + ".dll").ToArray());
		}

		public static Assembly Compile(string source, string[] refAssemblyNames)
		{
			var parameters = new CompilerParameters
			{
				GenerateInMemory = true,
			};

			parameters.ReferencedAssemblies.AddRange(refAssemblyNames);

			return Compile(source, parameters);
		}

		public static Assembly Compile(string source, string[] refAssemblyNames, string dllName)
		{
			var parameters = new CompilerParameters
			{
				GenerateInMemory = true,
				OutputAssembly = dllName
			};


			parameters.ReferencedAssemblies.AddRange(refAssemblyNames);

			return Compile(source, parameters);
		}

		public static Assembly Compile(string source, CompilerParameters parameters)
		{
			var provider = new CSharpCodeProvider();

			var result = provider.CompileAssemblyFromSource(parameters, source);

			return result.CompiledAssembly;
		}
	}
}
