﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aDefaultTypeMap
{
	public class zDefaultTypeMap
	{
		public static Dictionary<string, string> Get()
		{
			var items = Names(
				"SByte", "sbyte",
				"Byte", "byte",
				"Int16", "short",
				"UInt16", "ushort",
				"Int32", "int",
				"UInt32", "uint",
				"Int64", "long",
				"UInt64", "ulong",
				"Char", "char",
				"Single", "float",
				"Double", "double",
				"Boolean", "bool",
				"Decimal", "decimal",
				"String", "string",
				"Void", "void",
				"Object", "object"
			);

			return items.ToDictionary(item => item.Before, item => item.After);
		}

		struct BeforeAfter { public string Before; public string After; }

		static IEnumerable<BeforeAfter> Names(params string[] values)
		{
			for (int i = 0; i < values.Length; i += 2)
			{
				yield return new BeforeAfter { Before = values[i], After = values[i + 1] };
			}
		}
	}
}
