﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using aDefaultTypeMap;
using aMultipleInheritance;

namespace aExtractInterface
{
	public class zExArg
	{
		/// <summary>
		/// インターフェース名。型引数も必要なら入れる。
		/// </summary>
		public string InterfaceName;

		/// <summary>
		/// インターフェースを抽出するクラスのType。
		/// </summary>
		public Type Type;

		/// <summary>
		/// usingのとこの文字列。規定値はusing System;
		/// </summary>
		public string[] Usings = new[]{ "using System;" };

		/// <summary>
		/// 名前空間名。
		/// </summary>
		public string NameSpace;

		/// <summary>
		/// アクセス修飾子。規定値は"public"
		/// </summary>
		public string Access = "public";

		/// <summary>
		/// インターフェース定義の前。属性とか。規定値はnull。
		/// </summary>
		public zCommentData CommentData = null;

		/// <summary>
		/// 属性など、直前に書く文字列。規定値は何もなし。
		/// </summary>
		public string[] Attributes = new string[0];

		/// <summary>
		/// インターフェース名の後。継承とか型制約とか。規定値は何もなし。
		/// </summary>
		public string[] AfterInterfaceName = new string[0];

		/// <summary>
		/// メンバ定義の前の文字列。追加したいメンバなど入れる。規定値は何もなし。
		/// </summary>
		public string[] BeforeMembers = new string[0];

		/// <summary>
		/// メンバ定義の後の文字列。追加したいメンバなど入れる。規定値は何もなし。
		/// </summary>
		public string[] AfterMembers = new string[0];

		/// <summary>
		/// 型名の変換。usingでかぶったのの名前を変えた時なんかに使う。規定値は予約語の変換のみ。
		/// </summary>
		public Dictionary<string, string> TypeNameMap = zDefaultTypeMap.Get();

		/// <summary>
		/// メンバ個別の設定。規定値はなにもなし。
		/// </summary>
		public Dictionary<string, zExMemberArg> MemberMap = new Dictionary<string, zExMemberArg>();


		/// <summary>
		/// InterfaceName, Type, NameSpaceは必ず入れる必要がある。
		/// </summary>
		public zExArg() { }
	}
}
