﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aMultipleInheritance
{
	/// <summary>
	/// 生成するクラスのデータ
	/// </summary>
	public class zClassData
	{
		/// <summary>
		/// クラス名。型引数なんかも書いちゃっていい。
		/// </summary>
		public string ClassName;

		/// <summary>
		/// アクセス修飾子。規定値はpublic
		/// </summary>
		public eAccess Access = eAccess.Public;

		/// <summary>
		/// 属する名前空間
		/// </summary>
		public string NameSpace;

		/// <summary>
		/// パーシャルかどうか。規定値はfalse。
		/// </summary>
		public bool IsPartial = false;

		/// <summary>
		/// スタティッククラスかどうか。規定値はfalse
		/// </summary>
		public bool IsStatic = false;

		/// <summary>
		/// usingのとこに入る文字列。規定値はusing System;
		/// </summary>
		public string[] Usings = new[] { "using System;" };

		/// <summary>
		/// コメントのデータ。規定値はnull。
		/// </summary>
		public zCommentData CommentData = null;

		/// <summary>
		/// 指定されたクラスについたVisualStudioCommentAttributeを使用する。規定値はnull。
		/// ここで設定するのはクラスのコメントだけで、メンバは関係ない。
		/// </summary>
		public Type ClassLevelComment = null;

		/// <summary>
		/// 属性等、直前の文字列。規定値は何もなし。
		/// </summary>
		public string[] Attributes = new string[0];

		/// <summary>
		/// 継承クラスの設定の後に書く文字列。型引数の制約とか。規定値は何もなし。
		/// </summary>
		public string[] AfterDerives = new string[0];

		/// <summary>
		/// コンストラクタを作るかどうか。規定値はtrue。
		/// </summary>
		public bool HasConstructor = true;

		/// <summary>
		/// ClassNameとNameSpaceは必ず入れる必要がある。
		/// </summary>
		public zClassData() { }
	}
}
