﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aMultipleInheritance
{
	/// <summary>
	/// メンバについて個別に設定したい時使う
	/// </summary>
	public class zMemberData 
	{
		/// <summary>
		/// 委譲先のメンバ名
		/// </summary>
		public string OriginalName;

		/// <summary>
		/// 委譲元のメンバ名
		/// </summary>
		public string NewName;

		/// <summary>
		/// 委譲先のインスタンスの名前
		/// </summary>
		public string InstanceName;

		/// <summary>
		/// このメンバを使うかどうか。規定値はtrue。
		/// </summary>
		public bool IsUsed = true;

		/// <summary>
		/// 委譲元のメンバをstaticにするかどうか。規定値はfalse。
		/// </summary>
		public bool IsStatic = false;

		/// <summary>
		/// 継承メンバを隠す時の、newのとこに入る文字列。overrideやvirtualにしてもいいかもしれない。規定値は何もなし。
		/// </summary>
		public string New = "";

		/// <summary>
		/// 委譲元のメンバのアクセス修飾子。規定値はpublic。
		/// </summary>
		public eAccess Access = eAccess.Public;

		/// <summary>
		/// ゲッターが異なるアクセス修飾子をとる場合に使う。規定値はNone。
		/// </summary>
		public eAccess GetterAccess = eAccess.None;

		/// <summary>
		/// セッターが異なるアクセス修飾子をとる場合に使う。規定値はNone。
		/// </summary>
		public eAccess SetterAccess = eAccess.None;

		/// <summary>
		/// フィールド、プロパティの場合ゲッター、セッターを作るか。規定値はNone。
		/// </summary>
		public eGetterSetter GetterSetter = eGetterSetter.None;

		/// <summary>
		/// メンバの前のコメントや属性。規定値はnull。
		/// </summary>
		public zCommentData CommentData = null;

		/// <summary>
		/// 属性等、直前の文字列。規定値は何もなし。
		/// </summary>
		public string[] Attributes = new string[0];

		/// <summary>
		/// OriginalName, NewName, InstanceName, Access, 
		/// プロパティ/フィールドの場合はGetterSetterを必ず入れる必要がある。
		/// </summary>
		public zMemberData() { }
	}
}
