﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Reflection;

using aSourceBuilder;
using aDictionaryExtension;

namespace aMultipleInheritance
{
	public partial class zMultipleInheritance
	{
		static void WriteEvents(zInheriData arg, zSourceBuilder b)
		{
			var flags = GetBinding(arg);

			var events = arg.Type.GetEvents(flags);

			foreach (var e in events)
			{
				var add = e.GetAddMethod(true);
				var remove = e.GetRemoveMethod(true);

				if (add != null && remove != null &&
					CanAccess(add, arg) && CanAccess(remove, arg))
				{
					var m = new zMemberData
					{
						OriginalName = e.Name,
						NewName = e.Name,
						InstanceName = add.IsStatic ? TypeName(arg.Type, arg.TypeNameMap) : arg.Name,
						IsStatic = arg.IsStatic,
						Access = arg.SameAccess ? Access(add) : arg.Access,
						New = arg.IsDerived && arg.Type.IsClass ? "new" :
							arg.SameVirtual && add.IsVirtual ? "virtual" : ""
					};

					WriteMember(e.Name, m, e, arg.MemberMap, new string[0], b, newMember =>  WriteEvent(e, newMember, arg.TypeNameMap, b));
				}
			}
		}

		static void WriteEvent(EventInfo info, zMemberData m, Dictionary<string, string> typeMap, zSourceBuilder b)
		{
			var access = Access(m.Access);

			//インターフェースの明示的実装の場合nullが返る
			var newName = access == null ? TypeName(info.DeclaringType, typeMap) + "." + m.NewName : m.NewName;
			access = access == null ? "" : access + " ";

			var New = m.New == "" ? "" : m.New + " ";

			b.Line(
				access + (m.IsStatic ? "static " : "") + New + "event " + TypeName(info.EventHandlerType, typeMap) + " " + newName).Line(
				"{").Indent(() =>{
					b.Line("add{ " + m.InstanceName + "." + m.OriginalName + " += value; }")
					 .Line("remove{ " + m.InstanceName + "." + m.OriginalName + " -= value; }");
				}).Line(
				"}");

		}
	}
}
