﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Reflection;

using aSourceBuilder;
using aMultipleInheritance;

namespace aMultipleInheritanceHelpler
{
	class zBeforeMemberString
	{
		/// <summary>
		/// paramの数が違っていると例外が飛ぶ
		/// </summary>
		public static string[] Do(zCommentData commentN, string[] attributes, MemberInfo infoN, string[] paramNames, zSourceBuilder b)
		{
			var list = new List<string>();

			if (commentN != null)
			{
				var comment = commentN;

				if (comment.Summary.Length != 0)
				{
					list.Add("/// <summary>");
					foreach (var s in comment.Summary)
					{
						list.Add("/// " + GetCommentStr(s, b));
					}
					list.Add("/// </summary>");
				}

				if (paramNames.Length != comment.Params.Length && comment.Params.Length != 0 &&
					comment.ThrowException)
				{
					throw new zBeforeMemberString_NumParamsException();
				}

				if (paramNames.Length == comment.Params.Length)
				{
					for (int i = 0; i < paramNames.Length; ++i)
					{
						if (comment.Params[i] != null)
						{
							list.Add("/// <param name=\"" + paramNames[i] + "\">" + GetCommentStr(comment.Params[i], b) + "</param>");
						}
					}
				}
				if (comment.Returns != null)
				{
					list.Add("/// <returns>" + GetCommentStr(comment.Returns, b) + "</returns>");
				}
			}
			else if(infoN != null)
			{
				var info = infoN;

				//コメントが指定されていないなら、
				var vsAttrs = info.GetCustomAttributes(typeof(VisualStudioCommentAttribute), false);
				if (vsAttrs.Length != 0)
				{
					var vs = (VisualStudioCommentAttribute)vsAttrs.Single();
					list.AddRange(vs.Xml);
				}
			}

			list.AddRange(attributes);

			return list.ToArray();
		}

		static string GetCommentStr(string str, zSourceBuilder b)
		{
			return String.Join("\r\n", InnerGetCommentStr(str, b).ToArray());
		}

		static IEnumerable<string> InnerGetCommentStr(string str, zSourceBuilder b)
		{
			var ss = str.Split(new[]{"\r\n"}, StringSplitOptions.None);

			if(ss.Length != 0)
			{
				yield return ss[0];
			}
			foreach (var s in ss.Skip(1))
			{
				yield return b.GetIndentString() + "/// " + s;
			}
		}
	}




	public class zBeforeMemberString_NumParamsException : Exception
	{
		public int yRealNumParams;
		public int yWroteNumParam;
		public string yMemberName;

		public zBeforeMemberString_NumParamsException(){}

		public string yToMessage(string className)
		{
			return String.Join("\r\n", Lines(
					"引数の数が違います。 " + className + yMemberName,
					"",
					"書いた数:" + yWroteNumParam,
					"実際の数:" + yRealNumParams));
		}

		string[] Lines(params string[] lines) { return lines; }
	}
}
