﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace aSourceBuilder
{
	public class zSourceBuilder
	{
		public List<string> List{ get; private set; }
		public int IndentLevel { get; set; }

		public zSourceBuilder() 
		{
			List = new List<string>();
		}

		public zSourceBuilder Line(params string[] lines)
		{
			Add(lines);
			return this;
		}

		public zSourceBuilder Add(string[] lines)
		{
			foreach(var line in lines)
			{
				List.Add(GetIndentString() + line);
			}
			return this;
		}

		public string GetIndentString()
		{
			return new string('\t', IndentLevel);
		}

		public zSourceBuilder Indent(Action action)
		{
			++IndentLevel;
			action();
			--IndentLevel;
			return this;
		}

		public zSourceBuilder IndentLine(params string[] lines)
		{
			return IndentAdd(lines);
		}

		public zSourceBuilder IndentAdd(string[] lines)
		{
			return Indent(() => this.Add(lines));
		}

		public override string ToString()
		{
			return String.Join("\r\n", List.ToArray());
		}
	}
}
